Package org.zkoss.zul

## Class Doublebox

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zk.ui.HtmlBasedComponent
    - - org.zkoss.zul.impl.XulElement
      - - org.zkoss.zul.impl.InputElement
        - - org.zkoss.zul.impl.FormatInputElement
          - - org.zkoss.zul.impl.NumberInputElement
            - - org.zkoss.zul.Doublebox

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `Disable`, `Readonly`, `Scope`, `ComponentCtrl`, `Constrainted`

      public class Doublebox
      extends NumberInputElement

  An edit box for holding an float point value (double).

  Default `getZclass()`: z-doublebox.(since 3.5.0)

  Author:
    henrichen
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `HtmlBasedComponent.ExtraCtrl`

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zul.impl.InputElement

      `_cols, _value`

    - ### Fields inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `_zclass`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Doublebox()` |
    `Doublebox​(double value)` |
    `Doublebox​(java.lang.Double value)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected java.lang.Object` | `coerceFromString​(java.lang.String value)` | Coerces the value passed to `InputElement.setText(java.lang.String)`.
    `protected java.lang.String` | `coerceToString​(java.lang.Object value)` | Coerces the value passed to `InputElement.setText(java.lang.String)`.
    `double` | `doubleValue()` | Returns the value in double.
    `PropertyAccess` | `getPropertyAccess​(java.lang.String prop)` | Returns the corresponding property access object from the given property name, if any.
    `java.lang.Double` | `getValue()` | Returns the value (in Double), might be null unless a constraint stops it.
    `java.lang.String` | `getZclass()` | Returns the ZK Cascading Style class for this component.
    `int` | `intValue()` | Returns the value in integer.
    `long` | `longValue()` | Returns the value in long.
    `void` | `setConstraint​(java.lang.String constr)` |
    `void` | `setValue​(double value)` | Sets the value (in double)
    `void` | `setValue​(java.lang.Double value)` | Sets the value (in Double).
    `short` | `shortValue()` | Returns the value in short.
    `java.lang.Object` | `unmarshall​(java.lang.Object value)` | Unmarshall value returned from client if needed.

    - ### Methods inherited from class org.zkoss.zul.impl.NumberInputElement

      `formatNumber, getDefaultFormat, getDefaultLocale, getLocale, getRoundingMode, isLocaleFormat, renderProperties, setLocale, setLocale, setRoundingMode, setRoundingMode, toNumberOnly`

    - ### Methods inherited from class org.zkoss.zul.impl.FormatInputElement

      `getFormat, getRealFormat, setFormat`

    - ### Methods inherited from class org.zkoss.zul.impl.InputElement

      `checkUserError, clearErrorMessage, clearErrorMessage, clone, getCols, getConstraint, getConstraintString, getErrorboxIconSclass, getErrorboxSclass, getErrorMessage, getInputAttributes, getInstant, getMaxlength, getName, getPlaceholder, getRawText, getRawValue, getTargetValue, getText, getType, isChildable, isDisabled, isInplace, isInstant, isMultiline, isReadonly, isValid, marshall, onWrongValue, select, service, setCols, setConstraint, setDisabled, setErrorboxIconSclass, setErrorboxSclass, setErrorMessage, setInplace, setInputAttributes, setInputAttributes, setInsertedText, setInstant, setMaxlength, setName, setPlaceholder, setRawValue, setReadonly, setSelectedText, setSelectionRange, setText, setValueDirectly, showCustomError, validate`

    - ### Methods inherited from class org.zkoss.zul.impl.XulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, setContext, setContext, setContextAttributes, setCtrlKeys, setPopup, setPopup, setPopupAttributes, setTooltip, setTooltip, setTooltipAttributes`

    - ### Methods inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `addSclass, evalCSSFlex, focus, getAction, getClientAction, getDraggable, getDroppable, getExtraCtrl, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTabindexInteger, getTooltiptext, getTop, getVflex, getWidth, getZindex, getZIndex, removeSclass, removeSclass, setAction, setClass, setClientAction, setDraggable, setDroppable, setFocus, setHeight, setHeight0, setHeightDirectly, setHflex, setHflex0, setHflexDirectly, setLeft, setLeftDirectly, setRenderdefer, setSclass, setStyle, setTabindex, setTabindex, setTooltiptext, setTop, setTopDirectly, setVflex, setVflex0, setVflexDirectly, setWidth, setWidth0, setWidthDirectly, setZclass, setZindex, setZIndex, setZIndexDirectly`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildAdded, beforeChildRemoved, beforeParentChanged, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetClass, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, isVisible, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, query, queryAll, redraw, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setMold, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisible, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, toString, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Doublebox

          public Doublebox()

    - #### Doublebox

          public Doublebox​(double value)
                    throws WrongValueException

      Throws:
        `WrongValueException`

    - #### Doublebox

          public Doublebox​(java.lang.Double value)
                    throws WrongValueException

      Throws:
        `WrongValueException`

  - ### Method Detail

    - #### getValue

          public java.lang.Double getValue()
                                    throws WrongValueException

      Returns the value (in Double), might be null unless a constraint stops it.
      Throws:
        `WrongValueException` - if user entered a wrong value

    - #### doubleValue

          public double doubleValue()
                             throws WrongValueException

      Returns the value in double. If null, zero is returned.
      Throws:
        `WrongValueException`

    - #### intValue

          public int intValue()
                       throws WrongValueException

      Returns the value in integer. If null, zero is returned.
      Throws:
        `WrongValueException`

    - #### longValue

          public long longValue()
                         throws WrongValueException

      Returns the value in long. If null, zero is returned.
      Throws:
        `WrongValueException`

    - #### shortValue

          public short shortValue()
                           throws WrongValueException

      Returns the value in short. If null, zero is returned.
      Throws:
        `WrongValueException`

    - #### setValue

          public void setValue​(java.lang.Double value)
                        throws WrongValueException

      Sets the value (in Double).
      Throws:
        `WrongValueException` - if value is wrong

    - #### setValue

          public void setValue​(double value)
                        throws WrongValueException

      Sets the value (in double)
      Throws:
        `WrongValueException` - if value is wrong

    - #### getZclass

          public java.lang.String getZclass()

      Description copied from class: `HtmlBasedComponent`
      Returns the ZK Cascading Style class for this component. It usually depends on the implementation of the mold (`AbstractComponent.getMold()`).

      Default: null (the default value depends on element).

      `HtmlBasedComponent.setZclass(java.lang.String)`) will completely replace the default style of a component. In other words, the default style of a component is associated with the default value of `HtmlBasedComponent.getZclass()`. Once it is changed, the default style won't be applied at all. If you want to perform small adjustments, use `HtmlBasedComponent.setSclass(java.lang.String)` instead.

      Overrides:
        `getZclass` in class `HtmlBasedComponent`
      See Also:
        `HtmlBasedComponent.getSclass()`

    - #### unmarshall

          public java.lang.Object unmarshall​(java.lang.Object value)

      Description copied from class: `InputElement`
      Unmarshall value returned from client if needed.

      Overrides it if the value returned is not JSON Compatible.

      Overrides:
        `unmarshall` in class `InputElement`
      Parameters:
        `value` - the value returned from client
      Returns:
        the unmarshalled value

    - #### setConstraint

          public void setConstraint​(java.lang.String constr)

      Overrides:
        `setConstraint` in class `InputElement`
      Parameters:
        `constr` - a list of constraints separated by comma. Example: no positive, no zero
      Since:
        10.2.0

    - #### coerceFromString

          protected java.lang.Object coerceFromString​(java.lang.String value)
                                               throws WrongValueException

      Description copied from class: `InputElement`
      Coerces the value passed to `InputElement.setText(java.lang.String)`.

      Deriving note:
      If you want to store the value in other type, say BigDecimal, you have to override `InputElement.coerceToString(java.lang.Object)` and `InputElement.coerceFromString(java.lang.String)` to convert between a string and your targeting type.

      Moreover, when `Textbox` is called, it calls this method with value = null. Derives shall handle this case properly.

      Specified by:
        `coerceFromString` in class `InputElement`
      Throws:
        `WrongValueException`

    - #### coerceToString

          protected java.lang.String coerceToString​(java.lang.Object value)

      Description copied from class: `InputElement`
      Coerces the value passed to `InputElement.setText(java.lang.String)`.

      Default: convert null to an empty string.

      Deriving note:
      If you want to store the value in other type, say BigDecimal, you have to override `InputElement.coerceToString(java.lang.Object)` and `InputElement.coerceFromString(java.lang.String)` to convert between a string and your targeting type.

      Specified by:
        `coerceToString` in class `InputElement`

    - #### getPropertyAccess

          public PropertyAccess getPropertyAccess​(java.lang.String prop)

      Description copied from interface: `ComponentCtrl`
      Returns the corresponding property access object from the given property name, if any.
      Specified by:
        `getPropertyAccess` in interface `ComponentCtrl`
      Overrides:
        `getPropertyAccess` in class `NumberInputElement`
      Parameters:
        `prop` - the name of the property
      Returns:
        null it means not to support for the property name.